require 'net/ping'

class Netmidget  
  attr_accessor :hostname,
                :site,
                :ip,
                :device_name,
                :log
                 
  def initialize(opts)
    @hostname = opts[:hostname] || `/bin/hostname`.chomp
    @site = opts[:site]
    @ip = opts[:ip]
    @device_name = opts[:device_name]
    @log = opts[:log] || nil
  end
  
  def device_str
    "#{site}::#{device_name}::#{ip}"
  end
  
  def ping
    Net::Ping::External.new(ip).ping?
  end
  
  def ping?
    if not resp = ping
      warn_str = "#{device_str} was unresponsive...trying again"
      log ? log.warn(warn_str) : puts(Time.now.to_s + ": " + warn_str)
      resp = ping
    end
    resp
  end
  
  def traceroute
    `/usr/sbin/traceroute -n -m 20 -w 2 #{ip} 2>&1`
  end
  
  def traceroute_output_str
    str = traceroute
    log ? log.error(str) : puts(str = (stdout_prefix + str))
    str
  end
  
  def stdout_prefix
    "#{Time.now.to_s}: #{hostname} "
  end
  
  def ping_output_str_prefix
    "Pinging #{device_str}: "
  end
  
  def ping_output_str_success
    str = ping_output_str_prefix + "Success"
    log ? log.info(str) : puts(str = (stdout_prefix + str))
    str
  end
  
  def ping_output_str_fail
    str = ping_output_str_prefix + "Fail"
    log ? log.error(str) : puts(str = (stdout_prefix + str))
    str
  end
  
end
